#include "widget.h"

Widget::Widget(QWidget *parent) : QWidget(parent) {
 label = new QLabel ("Знак + или - покажет \n\
соответствие ввода шаблону",this);
 button = new QPushButton("Выход",this);
 lineEdit = new QLineEdit(this);
 QGridLayout *layout = new QGridLayout(this);
 layout->addWidget(lineEdit,0,0);
 layout->addWidget(button,0,1);
 layout->addWidget(label,1,0,1,2);
 connect(lineEdit,SIGNAL(textChanged(QString)),
         this,SLOT(slot1())); //наш слот
 connect(button,SIGNAL(clicked(bool)),
         this,SLOT(close())); //стандартный слот
 setLayout(layout);
}
void Widget::slot1() {
 QString str = lineEdit->text();
 QString tmpl="^[\\+|\\-]?\\d*([\\.|,]?\\d*)$";
 //^       [\\+|\\-]? \\d*          ([\\.|,]? \\d*)    $
 //начало  знак       цифры         . или ,   цифры    конец
 //строки  числа      целой части             дробной  строки
 //                   части                   части
 QRegExp *q = new QRegExp(tmpl);
 label->setText(q->indexIn(str)!=-1?"+":"-");
}

Widget::~Widget() {
 delete lineEdit;
 delete button;
 delete label;
}
